<?php
/* --------------------------------------------------------------------

  Chevereto
  http://chevereto.com/

  @version	2.3.1
  @author	Rodolfo Berríos A. <http://rodolfoberrios.com/>
			<inbox@rodolfoberrios.com>

  Copyright (C) 2008-2012 Rodolfo Berríos A. All rights reserved.
  
  BY USING THIS SOFTWARE YOU DECLARE TO ACCEPT THE CHEVERETO EULA
  http://chevereto.com/license

  --------------------------------------------------------------------- */

if(!defined('access') or !access) die('This file cannot be directly accessed.');

/*
 * INCLUDE TAGS
 ******************************************************************************/
 
/**
 * include_theme_header()
 * Includes the header.php file
 */
function include_theme_header() {
	include(__CHV_PATH_THEME__.'header.php');
}
/**
 * include_theme_footer()
 * Includes the footer.php file
 */
function include_theme_footer() {
	include(__CHV_PATH_THEME__.'footer.php');
}


/*
 * ASSETS
 ******************************************************************************/

function get_jquery() {
	return __CHV_URL_SYSTEM_JS__.'jquery.min.js';
}
function show_jquery() {
	echo get_jquery();
}


/*
 * SETUP INFO TAGS
 ******************************************************************************/

/**
 * show_version
 * Echoes the current script version
 */
function show_version() {
	echo version();
}

/**
 * show_domain
 * Echoes the site domain
 */
function show_domain() {
	echo HTTP_HOST;
}

/**
 * get_base_url
 * Retrives the base url of the script
 */
function get_base_url() {
	return __CHV_BASE_URL__;
}
function show_base_url() {
	echo get_base_url();
}

/**
 * get_default_lang
 * Returns the default language used
 */
function get_default_lang() {
	return chevereto_config('lang');
}
function show_default_lang() {
	echo get_default_lang();
}

/**
 * get_max_upload_size
 * Returns the max. imagesize by config
 */
function get_max_upload_size() {
	return chevereto_config('max_filesize');
}
function show_max_upload_size() {
	echo get_max_upload_size();
}

/**
 * get_tinyurl_service
 * echoes the current short url service
 */
function get_tinyurl_service() {
	switch(chevereto_config('short_url_service')) {
		case 'tinyurl':
		default:
			$tiny_service = 'TinyURL';
		break;
		case 'google':
			$tiny_service = 'Google';
		break;
		case 'isgd':
			$tiny_service = 'is.gd';
		break;
		case 'bitly':
			$tiny_service = 'bit.ly';
		break;
		case 'custom':
			$tiny_service = check_value(chevereto_config('custom_short_url_service')) ? chevereto_config('custom_short_url_service') : 'custom service';
		break;
	}
	echo $tiny_service;
}
function show_tinyurl_service() {
	echo get_tinyurl_service();
}


/*
 * THEME INFO TAGS
 ******************************************************************************/

/**
 * is_html_tag
 * returns true if the argument is some kind of html <tag>
 * TODO: Validate actual true HTML tags.
 */
function is_html_tag($tag) {
	return (strlen($tag) == strlen(strip_tags($tag))) ? false : true;
}

/**
 * get_theme_name
 * Returns the theme name
 */
function get_theme_name() {
	return chevereto_config('theme');
}
function show_theme_name() {
	echo get_theme_name();
}
 
/**
 * get_theme_url
 * Returns the theme url
 */
function get_theme_url() {
	return __CHV_URL_THEME__;
}
function show_theme_url() {
	echo __CHV_URL_THEME__;
}

/**
 * get_theme_imgdir
 * Get the image dir of the current theme
 */
function get_theme_imgdir() {
	return __CHV_URL_THEME__.'theme-img/';
}
function show_theme_imgdir() {
	echo get_theme_imgdir();
}


/*
 * LANGUAGE TAGS
 ******************************************************************************/
 
/**
 * get_lang_used
 * Returns the current used language code
 */
function get_lang_used() {
	return basename(dirname(__CHV_LANGUAGE_FILE__));
}
function show_lang_used() {
	echo get_lang_used();
}


/*
 * IMAGE TAGS
 ******************************************************************************/
 
/**
 * show_img_filename
 * echoes the filename.ext of the image
 */
function show_img_filename() {
	echo get_img_filename();
}

/**
 * show_image_width
 * echoes the image width
 */
function show_image_width() {
	echo get_image_width();
}

/**
 * show_image_height
 * echoes the image height
 */
function show_image_height() {
	echo get_image_height();
}

/**
 * get_img_dimentions
 * Returns the image width x height
 */
function get_img_dimentions() {
	return get_image_width().' x '.get_image_height().' pixels';
}
function show_img_dimentions() {
	echo get_img_dimentions();
}

/**
 * show_img_html_size
 * echoes the image width x height like html attr
 */
function show_img_html_size() {
	echo get_img_html_size();
}

/**
 * show_img_weight
 * echoes the image weight (filesize)
 */
function show_img_weight() {
	echo get_img_weight();
}

/**
 * show_image_url
 * echoes the img url
 */
function show_img_url() {
	echo get_img_url();
}

/**
 * show_img_viewer()
 * echoes the viewer url
 */
function show_img_viewer() {
	echo get_img_viewer();
}

/**
 * get_short_url
 * Returns the short url
 * TODO: by db!
 */
function get_short_url($type='service') {
	if($type=='service') {
		@session_start;
		$image_id = get_image_id();
		if(isset($_SESSION['ImagesUp']) && check_value($_SESSION['ImagesUp'][$image_id]['shorturl'])) {
			return $_SESSION['ImagesUp'][$image_id]['shorturl'];
		}
		$url = (chevereto_config('short_url_image')=='direct') ? get_img_url() : get_img_viewer();
		require(__CHV_PATH_INCLUDES__.'shorturl.php');
		$short_url = $ShortURL->get_ShortURL($url);
		$_SESSION['ImagesUp'][$image_id]['shorturl'] = $short_url;
		return $short_url;
	} else {
		return get_img_shorturl();
	}
}
function show_short_url($type='service') {
	echo get_short_url($type);
}

/**
 * get_img_html
 * Returns the img as html
 */
function get_img_html() {
	return htmlentities('<img src="'.get_img_url().'" border="0" />');
}
function show_img_html() {
	echo get_img_html();
}

/**
 * get_img_bbcode
 * Returns the img as bbcode
 */
function get_img_bbcode() {
	return htmlentities('[img]'.get_img_url().'[/img]');
}
function show_img_bbcode() {
	echo get_img_bbcode();
}


/**
 * show_thumb_url
 * echoes the thumb real url
 */
function show_thumb_url() {
	echo get_thumb_url();
}


/**
 * get_thumb_html
 * Returns the thumb + img link as html
 * arg -> true  : uses the full image URL
 * arg -> false : uses the viewer URL
 */
function get_thumb_html($full=true) {
	if($full) {
		$href = get_img_url();
	} else {
		$href = get_img_viewer();
	}
	return htmlentities('<a href="'.$href.'"><img src="'.get_thumb_url().'" border="0" /></a>');
}
function show_thumb_html($full=true) {
	echo get_thumb_html($full);
}

/**
 * get_thumb_bbcode
 * Returns the thumb + img link as bbcode
 * arg -> true  : uses the full image URL
 * arg -> false : uses the viewer URL
 */
function get_thumb_bbcode($full=true) {
	$html_version = html_entity_decode(get_thumb_html($full));
	return str_replace('<a href="', '[url=', str_replace('"><img src="', '][img]', str_replace('" border="0" /></a>', '[/img][/url]', $html_version)));
}
function show_thumb_bbcode($full=true) {
	echo get_thumb_bbcode($full);
}


/*
 * AUXILIARY TAGS
 ******************************************************************************/

/**
 * show_doctitle
 * echoes the page doctitle
 */
function show_doctitle() {
	echo get_doctitle();
}


/**
 * show_chevereto_header
 * Get the chevereto header including js and doctitle
 */
function show_chevereto_header() {
	$doctitle = check_value(get_doctitle()) ? get_doctitle().' - ' : '';
	$echo =  '<noscript><meta http-equiv="refresh" content="0;url='.__CHV_BASE_URL__.'error-javascript" /></noscript>

<script type="text/javascript" src="'.__CHV_URL_SYSTEM_JS__.'jquery.min.js"></script>
<script type="text/javascript" src="'.__CHV_URL_SYSTEM_JS__.'jquery.easing.js"></script>
<script type="text/javascript" src="'.__CHV_URL_SYSTEM_JS__.'jquery.uploadify-3.1_chevereto.js"></script>

<script type="text/javascript" src="'.__CHV_URL_SYSTEM_JS__.'peafowl.php"></script>

<link href="'.__CHV_URL_THEME__.'style.css" rel="stylesheet" type="text/css" />
<link href="'.__CHV_URL_THEME__.'uploadify.css" rel="stylesheet" type="text/css" />

<link href="'.__CHV_URL_THEME__.'favicon.ico" rel="shortcut icon" type="image/x-icon" />

<meta name="generator" content="Chevereto '.version().'" />

<meta name="description" content="'.chevereto_config('meta_description').'" />
<meta name="keywords" content="'.chevereto_config('meta_keywords').'" />

<title>'.$doctitle.chevereto_config('doctitle').'</title>';

	if(check_value(chevereto_config('facebook_app_id'))) {
		$echo .= "\n\n";
		$echo .= '<meta property="fb:app_id" content="'.chevereto_config('facebook_app_id').'" />'."\n";
		$echo .= '<script>
		(function(d, s, id) {
              var js, fjs = d.getElementsByTagName(s)[0];
              if (d.getElementById(id)) return;
              js = d.createElement(s); js.id = id;
              js.src = "//connect.facebook.net/'.get_lang_locale().'/all.js#xfbml=1&appId='.chevereto_config('facebook_app_id').'";
              fjs.parentNode.insertBefore(js, fjs);
            }(document, "script", "facebook-jssdk"));</script>'."\n";
	}
	
	echo $echo;

}

/**
 * show_page_links
 * echoes the setted pages
 */
function show_page_links($tag) {
	$html_tag = is_html_tag($tag) ? $tag : '';
	$html_closing_tag = html_closing_tag($html_tag);
	require(__CHV_PATH_THEME__.'pages/pages_config.php');
	foreach($pages_config as $key => $value) {
		if($value['live']) echo $html_tag.'<a href="'.__CHV_RELATIVE_ROOT__.$key.'">'.$value['title'].'</a>'.$html_closing_tag;
	}
}

/**
 * html_closing_tag
 * returns the closing </tag> for a given <tag>
 */
function html_closing_tag($html_tag) {
	return str_replace('<', '</', $html_tag);
} 

?>